<!DOCTYPE html>
<html>
   <head>
      <meta http-equiv="pragma"        content="no-cache">
      <meta http-equiv='content-type'  content='text/html; charset=utf-8'>
      <title>Wrightia :: Snapshot Collector</title>
      %invoke wia.pub.isspscoll.ui.util:getStyleMetadata%
      <link rel="stylesheet" type="text/css" href="%value WmRoot/cssFilename%">
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/wrightia.css">
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/onlinedoc.css">
      <link rel="stylesheet" type="text/css" href="css/package.css" />
      <link rel="stylesheet" type="text/css" href="/WiaRoot/css/no-quirks.css">
      <script type="text/javascript" src="/WiaRoot/scripts/wia4dom.js"></script>
      <script type="text/javascript" src="/WiaRoot/scripts/wiautil.js"></script>
      %end invoke%
      <style>
         #selStart, #selEnd { width: 160px; }
      </style>

      <script type="text/javascript">
         <!-- // Activate cloak
         var mServerIds = [];

         function setSnapshotId(snapshotId)
         /*****************************/{
            var xResult = false;

            if (snapshotId)
               {
               var xSingleSnapshotId = document.getElementById("singleSnapshotId");

               if (xSingleSnapshotId)
                  {
                  xSingleSnapshotId.value = snapshotId;

                  // clear any other selections
                  setAllSnapshots(false);

                  xResult = true;
                  }
               }

            return xResult;
         }

         function setAllSnapshots(isChecked)
         /*****************************/{
            var xSnapshotIds = getElementsByName("input", "snapshotIds");

            if (xSnapshotIds)
               for(var xIdx = 0; xIdx < xSnapshotIds.length; xIdx++)
                  xSnapshotIds[xIdx].checked = isChecked;
         }

         /**
          * Set the arguments of option links, **preserving** the current page context
          * in terms of what servers have been previosly selected.
          */
         function setAnchorArguments()
         /*****************************/{
            if (mServerIds && mServerIds.length > 0)
               {
               var xArgs = "serverIds=" + mServerIds[0];
               for(var xIdx = 1; xIdx < mServerIds.length; xIdx++)
                  xArgs += "&serverIds=" + mServerIds[xIdx];

               var xLG = document.getElementById("launch-gatherer");
               if (xLG)
                  xLG.setAttribute("href", "snapshot-select.dsp?" + xArgs + "&action=gather");

               var xR = document.getElementById("refresh");
               if (xR)
                  xR.setAttribute("href", "snapshot-select.dsp?" + xArgs);
               }
         }

         function selectBySampleDate()
         /*****************************/{
            var xCheckBoxes         = getElementsByName("input", "snapshotIds");
            var xSelectionStartDate = document.getElementById("selStart");
            var xSelectionEndDate   = document.getElementById("selEnd"  );

            if (xCheckBoxes)
               {
               if (xSelectionStartDate)
                  xSelectionStartDate = xSelectionStartDate.value;

               if (xSelectionEndDate)
                  xSelectionEndDate   = xSelectionEndDate.value;

               for(var xIdx = 0; xIdx < xCheckBoxes.length; xIdx++)
                  {
                  var xSelectable = false;

                  if (xSelectionStartDate)
                     {
                     var xInput = document.getElementById("sb_" + xIdx);

                     if (xInput)
                        {
                        var xComparable = getComparableStartTimestamp(xSelectionStartDate);
                        xSelectable = (xInput.innerHTML.trim() >= xComparable);
                        }
                     }
                  else
                     xSelectable = true;

                  if (xSelectable)
                     if (xSelectionEndDate)
                        {
                        var xInput = document.getElementById("se_" + xIdx);

                        if (xInput)
                           {
                           var xComparable = getComparableEndTimestamp(xSelectionEndDate);
                           xSelectable = (xInput.innerHTML.trim() <= xComparable);
                           }
                        }

                  xCheckBoxes[xIdx].checked = xSelectable;
                  }
               }

            return true;
         }

         function getComparableStartTimestamp(value)
         /*****************************/{
            return getComparableTimestamp(value, "0000-00-00 00:00:00.000");
         }

         function getComparableEndTimestamp(value)
         /*****************************/{
            return getComparableTimestamp(value, "9999-99-99 99:99:99.999");
         }

         function getComparableTimestamp(value, mask)
         /*****************************/{
            return value + mask.substring(value.length)
         }

         // Deactivate cloak -->
      </script>
   </head>

   <body>
      <table class="topContainer">
         <tr>
            <td class="menusection menusection-SnapshotCollector" colspan="2">Server Selection > Snapshot Selection</td>
         </tr>
         <tr>
            <td>
               <ul>
                  <li><a href="server-select.dsp">Back to Server Selection</a></li>
                  %invoke wia.pub.isspscoll.ui.selectSnapshot.util:getSelectedServerIds%
                     %ifvar serverIds%
                        <li><a id="launch-gatherer" href="snapshot-select.dsp?action=gather">Launch a Snapshot Gatherer Now</a></li>
                        <li><a id="refresh" href="snapshot-select.dsp">Refresh</a></li>

                        <script type="text/javascript">
                           var mServerIds = [%loop serverIds%"%value%"%loopsep ', '%%end loop%];
                           setAnchorArguments();
                        </script>
                     %endif%
                  %end invoke%
               </ul>
            </td>
            <td class="navbar">
               <ul>
                  <li><a href="./">Home</a></li>
                  <li><a href="doc/PackageHelp.html#snapshotselection" target="isspcoll_onlinehelp">Help</a></li>
               </ul>
            </td>
         </tr>
      </table>
      <table class="mainContainer"><!-- this table is being used only to set a left indentation to the child tables -->
         %ifvar action equals('gather')%
            %invoke wia.pub.isspscoll.ui.selectSnapshot:launchGatherer%
            %onerror%
            <tr>
               <td class="message" colspan="2">
                  Error launching the Snapshot Gatherer service.</br>
                  %value errorMessage encode(xml)%
               </td>
            </tr>
            %end invoke%
         %endif%
         <tr>
            <td width="10">&nbsp;</td>
            <td>
               <div class="note">
                  <p>
                     Select a snapshot to load into the local <span class="productname">Service Profiler</span> for viewing.
                  </p>
                  <form>
                     <input type="button" value="Select" onclick="javascript: selectBySampleDate();"/>
                     samples with <span class="systemname">Start Date</span> &ge; <input type="text" id="selStart"/>
                     and with <span class="systemname">End Date</span> &le; <input type="text" id="selEnd"/>.
                  </form>
               </div>
               <form name="frmMain" method="post" action="snapshot-load.dsp">
                  <table name="formContainer" class="formContainer">
                     %invoke wia.pub.isspscoll.ui.selectSnapshot:build%
                        <thead>
                           <tr class="heading">
                              <td colspan="6">
                                 List of Saved Snapshots
                                 <input type="hidden" name="snapshotId" id="singleSnapshotId" />
                              </td>
                           </tr>
                           <tr>
                              <td class="columnHeading-c"><input type="checkbox" onclick="javascript: setAllSnapshots(this.checked)" /></td>
                              <td class="columnHeading">Host</td>
                              <td class="columnHeading">Port</td>
                              <td class="columnHeading">Sample Start</td>
                              <td class="columnHeading">Sample End</td>
                              <td class="columnHeading-c">Upload</td>
                           </tr>
                        </thead>
                        <tbody>
                           %loop SnapshotsInfo%
                              <tr class="selectableRowStripped">
                                 <td class="oddrowdata"><input type="checkbox" id="s_%value $index%" name="snapshotIds" value="%value serverId%,%value snapshotId%"/></td>
                                 <td class="oddrow-l">%value hostname%</td>
                                 <td class="oddrow-l">%value port%</td>
                                 <td class="oddrow-l" id="sb_%value $index%">%value sampleStartDate%</td>
                                 <td class="oddrow-l" id="se_%value $index%">%value sampleEndDate%</td>
                                 <td class="oddrowdata"><input type="submit" value="Go" onclick="return setSnapshotId('%value serverId%,%value snapshotId%');"/></td>
                              </tr>
                           %end loop%
                        </tbody>
                        <tfoot>
                           <tr>
                              <td class="action" colspan="6">
                                 <input type="submit" name="merge" value="Merge Selected &amp; Load" />
                              </td>
                           </tr>
                        <tfoot>
                     %onerror%
                        <tr>
                           <td class="message" colspan="6">
                              An error occurred trying to build the report data.
                              Check by executing the '%value errorService%' service on a browser.
                              The error details are as follows: <br/><br/>
                              %value errorMessage encode(xml)%
                           </td>
                        </tr>
                     %end invoke%
                  </table>
               </form>
            </td>
         </tr>
      </table>
   </body>
</html>
